---
title: CanvasRenderingContext2D.textBaseline
slug: Web/API/CanvasRenderingContext2D/textBaseline
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Property
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.textBaseline</code></strong> property of the Canvas 2D API specifies the current text baseline used when drawing text.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>ctx</em>.textBaseline = "top" || "hanging" || "middle" || "alphabetic" || "ideographic" || "bottom";
</pre>

<h3 id="Options">Options</h3>

<p>Possible values:</p>

<dl>
 <dt><code>"top"</code></dt>
 <dd>The text baseline is the top of the em square.</dd>
 <dt><code>"hanging"</code></dt>
 <dd>The text baseline is the hanging baseline. (Used by Tibetan and other Indic scripts.)</dd>
 <dt><code>"middle"</code></dt>
 <dd>The text baseline is the middle of the em square.</dd>
 <dt><code>"alphabetic"</code></dt>
 <dd>The text baseline is the normal alphabetic baseline. Default value.</dd>
 <dt><code>"ideographic"</code></dt>
 <dd>The text baseline is the ideographic baseline; this is the bottom of the body of the characters, if the main body of characters protrudes beneath the alphabetic baseline. (Used by Chinese, Japanese, and Korean scripts.)</dd>
 <dt><code>"bottom"</code></dt>
 <dd>The text baseline is the bottom of the bounding box. This differs from the ideographic baseline in that the ideographic baseline doesn't consider descenders.</dd>
</dl>

<p>The default value is <code>"alphabetic"</code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Comparison_of_property_values">Comparison of property values</h3>

<p>This example demonstrates the various <code>textBaseline</code> property values.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas" width="550" height="500"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

const baselines = ['top', 'hanging', 'middle', 'alphabetic', 'ideographic', 'bottom'];
ctx.font = '36px serif';
ctx.strokeStyle = 'red';

baselines.forEach(function (baseline, index) {
  ctx.textBaseline = baseline;
  const y = 75 + index * 75;
  ctx.beginPath();
  ctx.moveTo(0, y + 0.5);
  ctx.lineTo(550, y + 0.5);
  ctx.stroke();
  ctx.fillText('Abcdefghijklmnop (' + baseline + ')', 0, y);
});
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Comparison_of_property_values', 700, 550) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-textbaseline", "CanvasRenderingContext2D.textBaseline")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.textBaseline")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this property: {{domxref("CanvasRenderingContext2D")}}</li>
</ul>
